#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_texture;

// {xLoc, yLoc, dist, thickness}
uniform vec4 shockwave;

uniform float x_mult;

varying vec2 v_texCoords;
varying vec4 v_color;

void main()
{

    vec2 coords = v_texCoords.xy;

    vec2 offset = v_texCoords.xy - shockwave.xy;

    float dist = sqrt(x_mult * offset.x * x_mult * offset.x + offset.y  * offset.y);

    vec4 texel = texture2D(u_texture, coords);

    if (dist <= shockwave.z + shockwave.w && dist >= shockwave.z - shockwave.w){
        // higher mag further from ring, polarized
        float diff = (shockwave.z - dist)/shockwave.w;
        // lower mag further from ring, nonpolarized
        float outer = 1.0 - abs(shockwave.z - dist)/shockwave.w;
        vec2 norm = normalize(offset);
        vec2 change = norm * diff * outer * shockwave.w;
        texel.r = texture2D(u_texture, coords - change).r;
        texel.g = texture2D(u_texture, coords + change).g;
    }

    gl_FragColor = texel;

}